#!/bin/bash

# -------------------------------------------------------------------------- #
# Copyright 2002-2012, OpenNebula Project Leads (OpenNebula.org)             #
#                                                                            #
# Licensed under the Apache License, Version 2.0 (the "License"); you may    #
# not use this file except in compliance with the License. You may obtain    #
# a copy of the License at                                                   #
#                                                                            #
# http://www.apache.org/licenses/LICENSE-2.0                                 #
#                                                                            #
# Unless required by applicable law or agreed to in writing, software        #
# distributed under the License is distributed on an "AS IS" BASIS,          #
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #
# See the License for the specific language governing permissions and        #
# limitations under the License.                                             #
#--------------------------------------------------------------------------- #

if [ -z "$ONE_LOCATION" ]; then
    ONE_PID=/var/run/one/oned.pid
    LOCK_FILE=/var/lock/one/one
    ACCTD_CMD=/usr/lib/one/ruby/acct/acctd.rb
    ACCTD_LOG=/var/log/one/oneacctd.log
    ACCTD_PID_FILE=/var/run/one/oneacctd.pid
else
    ONE_PID=$ONE_LOCATION/var/oned.pid
    LOCK_FILE=$ONE_LOCATION/var/.lock
    ACCTD_CMD=$ONE_LOCATION/lib/ruby/acct/acctd.rb
    ACCTD_LOG=$ONE_LOCATION/var/oneacctd.log
    ACCTD_PID_FILE=$ONE_LOCATION/var/oneacctd.pid
fi

function oned_running {
    ONEPID=`cat $ONE_PID 2> /dev/null`
    ps $ONEPID > /dev/null 2>&1
    if [ ! -f "$LOCK_FILE" -o ! -f "$ONE_PID" -o $? -ne 0 ]; then
        echo oned not running
        exit 1
    fi
}

function acctd_running {
    ACCTD_PID=`cat $ACCTD_PID_FILE 2>/dev/null`
    ps "$ACCTD_PID" &> /dev/null
}

COMMAND=$1

case $COMMAND in
start)
    # check if OpenNebula running
    oned_running

    # check if acct already running
    acctd_running
    if [ "$?" = "0" ]; then
        echo "oneacctd already running."
        exit 1
    fi

    # acctd not running, safe to start
    $ACCTD_CMD &> $ACCTD_LOG &
    
    LASTRC=$?
    LASTPID=$!

    if [ $LASTRC -ne 0 ]; then
      echo "Error executing oneacctd."
      echo "Check $ACCTD_LOG for more information"
      exit 1
    else
      echo $LASTPID > $ACCTD_PID_FILE
    fi

    sleep 2
    ps $LASTPID > /dev/null 2>&1

    if [ $? -ne 0 ]; then
      echo "Error executing oneacctd."
      echo "Check $ACCTD_LOG for more information"
      exit 1
    fi

    echo "oneacctd started"
    ;;
stop)
    # check if running
    acctd_running
    if [ "$?" != "0" ]; then
        echo "oneacctd not running."
        exit 1
    fi

    # acctd running, safe to stop
    ACCTD_PID=`cat $ACCTD_PID_FILE 2>/dev/null`
    kill $ACCTD_PID &> /dev/null
    rm -f $ACCTD_PID_FILE &> /dev/null
    
    echo "oneacctd stop"
    ;;
*)
    echo "Usage: oneacctd {start|stop}" >&2
    exit 3
    ;;
esac
